from syncloud.remote import remoteaccess


class ServerFacade:
    def __init__(self, sam, insider, remote_access, tools):
        self.sam = sam
        self.insider = insider
        self.remote_access = remote_access
        self.tools = tools


    def activate(self, release, domain, api_url, email, password, user_domain):

        self.sam.update(release)
        self.sam.upgrade_all()

        self.insider.set_redirect_info(domain, api_url)
        self.insider.acquire_domain(email, password, user_domain)

        private_key = self.remote_access.enable()

        return {
            'id': self.tools.id(),
            'name': user_domain + "." + domain,
            'endpoint' : {
                #Fix toold id to return host
                'host': 'host',
                'port': remoteaccess.SERVICE_PORT,
            },
            'credentials': {
                'login': 'root',
                'password': 'syncloud',
                'private_key': private_key
            }
        }